1; # textrahmen.pm
package text;

@font=(-font,'6x13'); @gfarbe=(-bg,'lightgoldenrod');
#######################################################################
sub rahmen {$RAHMEN=$::fenster->Frame(-borderwidth,5,@gfarbe)
    ->pack(-side,'right',-fill,'y');
  oben(); text(); unten()}
#######################################################################
sub oben {my $OBEN=$RAHMEN->Frame(@gfarbe)->pack(-fill,'x');
  my $ende=$OBEN->Button(-text,'Fine',-command,\&::ende);
  $speichern=$OBEN->Button(-text,'salva',-command,\&speichern);
  my $make=$OBEN->Button(-text,'make',-command,\&bef::make);
  my $alfa=$OBEN->Button(-text,'alfa',-command,\&bef::alfa);
  my $undo=$OBEN->Button(-text,'undo',-command,\&undo);
  for ($speichern,$make,$alfa,$undo,$ende)
    {$_->configure(@font,-relief,'solid',@gfarbe,
       -borderwidth,0,-activebackground,'lightcyan',
       -highlightthickness,0),
    $_->pack(-side,'left')}
  $speichern->configure(-activebackground,'lightgoldenrod')}

sub text {$text=$RAHMEN->Scrolled('TextUndo',-width,80,-height,39,
     -background,"lemonchiffon",-padx,15,-pady,15,-wrap,'word',
     -borderwidth,4,-relief,'sunken',@font,
     -insertwidth,4,-insertbackground,'maroon1',
     -insertofftime,0,-scrollbars,'osow')->pack();
  for ('yscrollbar','xscrollbar')
    {$text->Subwidget($_)->configure(-bg,'darkgray',
    -activebackground,'darkgray',-troughcolor,'lightgoldenrod')}
  sonderzeichen();
  $file='/home/sis/alfa'; files::schreib($file,'') if not -f $file;
  oeffne($file)}

sub undo {$text->undo; speicherfarbe()}

sub unten {my $UNTEN=$RAHMEN->Frame(@gfarbe)->pack(-fill,'x');
  $UNTEN->Label(-textvariable,\$name90,@gfarbe,
    @font,-anchor,'w')->pack(-fill,'x');
  my $UNTENb=$UNTEN->Frame->pack(-fill,'x');
  $UNTENb->Label(-textvariable,\$filestat,@gfarbe,
    @font,-anchor,'w')->pack(-side,'left',-fill,'x',-expand,1);
  my $UNTENc=$UNTEN->Frame->pack(-fill,'x');
  bef::eingabe($UNTENc)}
######################################################################
sub oeffne {my $name=shift; $name90=substr($name,-90);
  loeschen(); $file=$name; files::schreib($name,'') unless -f $name;
  ein(files::lies($name)); # bearbeite($text);
  my ($v)=::wegundname($file); verzeichnisse::oeffneverzeichnis($v);
  $text->focus; speicherfarbe(0);
  my $stat=::stat($file);
  my $mode=sprintf("%04o",$stat->mode&07777); my $size=$stat->size;
  my $mzeit=scalar localtime($stat->mtime);
  my $besitzer=::besitzer($stat->uid);
  my $gruppe=::gruppe($stat->gid);
  $filestat="$mode  $besitzer.$gruppe  ($size)  $mzeit    "}

sub speichern {files::schreib($file,buffer())
  if $ungespeichert; speicherfarbe(0)}

sub speicherfarbe {my $a=shift; $a=1 unless defined $a;
  if ($a==0) {$speichern->configure(@gfarbe,
    -activebackground,'lightgoldenrod'); $ungespeichert=0}
  else {$speichern->configure(-bg,'lightgreen',
    -activebackground,'lightgreen'); $ungespeichert=1}}



